import { InjectionToken, ɵɵinject, ɵɵdefineInjectable, ɵsetClassMetadata, Injectable, Inject, ɵɵdefineComponent, ɵɵelementStart, ɵɵtext, ɵɵelementEnd, Component, ɵɵdirectiveInject, ɵɵlistener, ɵɵelement, ɵɵproperty, ɵɵdefineNgModule, ɵɵdefineInjector, ɵɵsetNgModuleScope, NgModule } from '@angular/core';
import { HttpClient, HttpClientModule } from '@angular/common/http';
import { FormControl, Validators, FormBuilder, ɵangular_packages_forms_forms_y, NgControlStatusGroup, FormGroupDirective, DefaultValueAccessor, NgControlStatus, FormControlName, ReactiveFormsModule } from '@angular/forms';
import { Router } from '@angular/router';
import { ToastrService, ToastrModule } from 'ngx-toastr';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { of } from 'rxjs';

const EnvironmentToken = new InjectionToken('config');
class LibraryEnvironment {
}

class LoginService {
    // loggedUser: LoggedUser;
    // get validUser(): boolean {
    //   return this.loggedUser ? true : false;
    // }
    // get userGuid(): string {
    //   return this.loggedUser.guid;
    // }
    constructor(environment, http) {
        this.environment = environment;
        this.http = http;
    }
    login(credentials) {
        const url = `${this.environment.warehouseApi}/login`;
        return this.http.post(url, credentials);
    }
}
LoginService.ɵfac = function LoginService_Factory(t) { return new (t || LoginService)(ɵɵinject(EnvironmentToken), ɵɵinject(HttpClient)); };
LoginService.ɵprov = ɵɵdefineInjectable({ token: LoginService, factory: LoginService.ɵfac, providedIn: 'root' });
/*@__PURE__*/ (function () { ɵsetClassMetadata(LoginService, [{
        type: Injectable,
        args: [{
                providedIn: 'root'
            }]
    }], function () { return [{ type: LibraryEnvironment, decorators: [{
                type: Inject,
                args: [EnvironmentToken]
            }] }, { type: HttpClient }]; }, null); })();

class ErrorPageComponent {
    constructor() { }
    ngOnInit() {
    }
}
ErrorPageComponent.ɵfac = function ErrorPageComponent_Factory(t) { return new (t || ErrorPageComponent)(); };
ErrorPageComponent.ɵcmp = ɵɵdefineComponent({ type: ErrorPageComponent, selectors: [["lib-error-page"]], decls: 2, vars: 0, template: function ErrorPageComponent_Template(rf, ctx) { if (rf & 1) {
        ɵɵelementStart(0, "p");
        ɵɵtext(1, "error-page works!");
        ɵɵelementEnd();
    } }, styles: [""] });
/*@__PURE__*/ (function () { ɵsetClassMetadata(ErrorPageComponent, [{
        type: Component,
        args: [{
                selector: 'lib-error-page',
                templateUrl: './error-page.component.html',
                styleUrls: ['./error-page.component.css']
            }]
    }], function () { return []; }, null); })();

class NotificationService {
    constructor(toastr) {
        this.toastr = toastr;
    }
    notify(message) {
        alert(message);
    }
    successmsg(message) {
        this.toastr.success(message, 'Success');
    }
    errorsmsg(message) {
        this.toastr.error(message, 'Error');
    }
    infotoastr(message) {
        this.toastr.info(message, 'Information');
    }
    toastrwaring(message) {
        this.toastr.warning(message, 'Warning');
    }
}
NotificationService.ɵfac = function NotificationService_Factory(t) { return new (t || NotificationService)(ɵɵinject(ToastrService)); };
NotificationService.ɵprov = ɵɵdefineInjectable({ token: NotificationService, factory: NotificationService.ɵfac, providedIn: 'root' });
/*@__PURE__*/ (function () { ɵsetClassMetadata(NotificationService, [{
        type: Injectable,
        args: [{
                providedIn: 'root'
            }]
    }], function () { return [{ type: ToastrService }]; }, null); })();

class ErrorHandlerService {
    constructor(notify) {
        this.notify = notify;
    }
    handleError(response) {
        if (response.status === 0) {
            this.notify.errorsmsg('Server nije dostupan.');
        }
        else if (response.status === 400) {
            this.notify.errorsmsg(`${response.error}.`);
        }
    }
}
ErrorHandlerService.ɵfac = function ErrorHandlerService_Factory(t) { return new (t || ErrorHandlerService)(ɵɵinject(NotificationService)); };
ErrorHandlerService.ɵprov = ɵɵdefineInjectable({ token: ErrorHandlerService, factory: ErrorHandlerService.ɵfac, providedIn: 'root' });
/*@__PURE__*/ (function () { ɵsetClassMetadata(ErrorHandlerService, [{
        type: Injectable,
        args: [{
                providedIn: 'root'
            }]
    }], function () { return [{ type: NotificationService }]; }, null); })();

class LoginComponent {
    constructor(formBuilder, loginService, router, errorHandlerService) {
        this.formBuilder = formBuilder;
        this.loginService = loginService;
        this.router = router;
        this.errorHandlerService = errorHandlerService;
        this.loginForm = this.formBuilder.group({
            username: new FormControl('', [Validators.required]),
            password: new FormControl('', [Validators.required])
        });
    }
    ngOnInit() {
        this.operaterAuthenticated();
    }
    submit() {
        const loginCerdentials = {
            username: this.loginForm.controls.username.value,
            password: this.loginForm.controls.password.value
        };
        this.loginService.login(loginCerdentials).subscribe(loginResponse => {
            // this.loginService.loggedUser = loginResponse;
            sessionStorage.setItem('loggedUser', JSON.stringify(loginResponse));
            this.operaterAuthenticated();
        }, error => {
            this.errorHandlerService.handleError(error);
        });
    }
    operaterAuthenticated() {
        if (sessionStorage.getItem('loggedUser')) {
            this.router.navigate(['dashboard', 'landing-page']);
        }
    }
    navigate(route) {
        this.router.navigate([route]);
    }
}
LoginComponent.ɵfac = function LoginComponent_Factory(t) { return new (t || LoginComponent)(ɵɵdirectiveInject(FormBuilder), ɵɵdirectiveInject(LoginService), ɵɵdirectiveInject(Router), ɵɵdirectiveInject(ErrorHandlerService)); };
LoginComponent.ɵcmp = ɵɵdefineComponent({ type: LoginComponent, selectors: [["app-login"]], decls: 14, vars: 1, consts: [["autocomplete", "off", 3, "formGroup", "ngSubmit"], [1, "flexbox-column-container", "jumbotron"], ["for", "username", 1, "flexbox-label"], ["type", "text", "formControlName", "username", 1, "flexbox-item"], ["for", "password", 1, "flexbox-label"], ["type", "password", "formControlName", "password", 1, "flexbox-item"], [1, "flexbox-label"], ["type", "submit", 1, "btn", "btn-primary", "flexbox-item"]], template: function LoginComponent_Template(rf, ctx) { if (rf & 1) {
        ɵɵelementStart(0, "form", 0);
        ɵɵlistener("ngSubmit", function LoginComponent_Template_form_ngSubmit_0_listener() { return ctx.submit(); });
        ɵɵelementStart(1, "div", 1);
        ɵɵelementStart(2, "div");
        ɵɵelementStart(3, "label", 2);
        ɵɵtext(4, "Username: ");
        ɵɵelementEnd();
        ɵɵelement(5, "input", 3);
        ɵɵelementEnd();
        ɵɵelementStart(6, "div");
        ɵɵelementStart(7, "label", 4);
        ɵɵtext(8, "Password: ");
        ɵɵelementEnd();
        ɵɵelement(9, "input", 5);
        ɵɵelementEnd();
        ɵɵelementStart(10, "div");
        ɵɵelement(11, "label", 6);
        ɵɵelementStart(12, "button", 7);
        ɵɵtext(13, "Login");
        ɵɵelementEnd();
        ɵɵelementEnd();
        ɵɵelementEnd();
        ɵɵelementEnd();
    } if (rf & 2) {
        ɵɵproperty("formGroup", ctx.loginForm);
    } }, directives: [ɵangular_packages_forms_forms_y, NgControlStatusGroup, FormGroupDirective, DefaultValueAccessor, NgControlStatus, FormControlName], styles: [""] });
/*@__PURE__*/ (function () { ɵsetClassMetadata(LoginComponent, [{
        type: Component,
        args: [{
                selector: 'app-login',
                templateUrl: './login.component.html',
                styleUrls: ['./login.component.css']
            }]
    }], function () { return [{ type: FormBuilder }, { type: LoginService }, { type: Router }, { type: ErrorHandlerService }]; }, null); })();

class WhLibraryModule {
    static forRoot(environment) {
        return {
            ngModule: WhLibraryModule,
            providers: [
                {
                    provide: EnvironmentToken,
                    useValue: environment
                }
            ]
        };
    }
}
WhLibraryModule.ɵmod = ɵɵdefineNgModule({ type: WhLibraryModule });
WhLibraryModule.ɵinj = ɵɵdefineInjector({ factory: function WhLibraryModule_Factory(t) { return new (t || WhLibraryModule)(); }, providers: [
        LoginService
    ], imports: [[
            HttpClientModule,
            ReactiveFormsModule,
            BrowserAnimationsModule,
            ToastrModule.forRoot({
                timeOut: 5000,
                positionClass: 'toast-bottom-full-width',
                preventDuplicates: true,
            })
        ]] });
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && ɵɵsetNgModuleScope(WhLibraryModule, { declarations: [LoginComponent,
        ErrorPageComponent], imports: [HttpClientModule,
        ReactiveFormsModule,
        BrowserAnimationsModule, ToastrModule], exports: [LoginComponent] }); })();
/*@__PURE__*/ (function () { ɵsetClassMetadata(WhLibraryModule, [{
        type: NgModule,
        args: [{
                declarations: [
                    LoginComponent,
                    ErrorPageComponent
                ],
                imports: [
                    HttpClientModule,
                    ReactiveFormsModule,
                    BrowserAnimationsModule,
                    ToastrModule.forRoot({
                        timeOut: 5000,
                        positionClass: 'toast-bottom-full-width',
                        preventDuplicates: true,
                    })
                ],
                providers: [
                    LoginService
                ],
                exports: [
                    LoginComponent
                ]
            }]
    }], null, null); })();

class Login {
}

class LoggedUser {
}

class AccessGuard {
    constructor(loginService) {
        this.loginService = loginService;
    }
    canActivate() {
        return sessionStorage.getItem('loggedUser') ? of(true) : of(false);
    }
}
AccessGuard.ɵfac = function AccessGuard_Factory(t) { return new (t || AccessGuard)(ɵɵinject(LoginService)); };
AccessGuard.ɵprov = ɵɵdefineInjectable({ token: AccessGuard, factory: AccessGuard.ɵfac, providedIn: 'root' });
/*@__PURE__*/ (function () { ɵsetClassMetadata(AccessGuard, [{
        type: Injectable,
        args: [{
                providedIn: 'root'
            }]
    }], function () { return [{ type: LoginService }]; }, null); })();

class HelperService {
    unsubscribeSubscriptions(subscriptions) {
        subscriptions.forEach(x => {
            if (x) {
                x.unsubscribe();
            }
        });
    }
}
HelperService.ɵfac = function HelperService_Factory(t) { return new (t || HelperService)(); };
HelperService.ɵprov = ɵɵdefineInjectable({ token: HelperService, factory: HelperService.ɵfac, providedIn: 'root' });
/*@__PURE__*/ (function () { ɵsetClassMetadata(HelperService, [{
        type: Injectable,
        args: [{
                providedIn: 'root'
            }]
    }], null, null); })();

class Category {
}

class Engine {
}

class Manufacturer {
}

class Model {
}

class Part {
}

class SubCategory {
}

/**
 * Generated bundle index. Do not edit.
 */

export { AccessGuard, Category, Engine, ErrorHandlerService, HelperService, LoggedUser, Login, LoginComponent, LoginService, Manufacturer, Model, NotificationService, Part, SubCategory, WhLibraryModule };
//# sourceMappingURL=wh-library.js.map
