import { InjectionToken, ɵɵinject, ɵɵdefineInjectable, ɵsetClassMetadata, Injectable, Inject, ɵɵdefineComponent, ɵɵelementStart, ɵɵtext, ɵɵelementEnd, Component, ɵɵdirectiveInject, ɵɵlistener, ɵɵelement, ɵɵproperty, ɵɵdefineNgModule, ɵɵdefineInjector, ɵɵsetNgModuleScope, NgModule } from '@angular/core';
import { HttpClient, HttpClientModule } from '@angular/common/http';
import { FormControl, Validators, FormBuilder, ɵangular_packages_forms_forms_y, NgControlStatusGroup, FormGroupDirective, DefaultValueAccessor, NgControlStatus, FormControlName, ReactiveFormsModule } from '@angular/forms';
import { Router } from '@angular/router';
import { ToastrService, ToastrModule } from 'ngx-toastr';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { of } from 'rxjs';

var EnvironmentToken = new InjectionToken('config');
var LibraryEnvironment = /** @class */ (function () {
    function LibraryEnvironment() {
    }
    return LibraryEnvironment;
}());

var LoginService = /** @class */ (function () {
    // loggedUser: LoggedUser;
    // get validUser(): boolean {
    //   return this.loggedUser ? true : false;
    // }
    // get userGuid(): string {
    //   return this.loggedUser.guid;
    // }
    function LoginService(environment, http) {
        this.environment = environment;
        this.http = http;
    }
    LoginService.prototype.login = function (credentials) {
        var url = this.environment.warehouseApi + "/login";
        return this.http.post(url, credentials);
    };
    LoginService.ɵfac = function LoginService_Factory(t) { return new (t || LoginService)(ɵɵinject(EnvironmentToken), ɵɵinject(HttpClient)); };
    LoginService.ɵprov = ɵɵdefineInjectable({ token: LoginService, factory: LoginService.ɵfac, providedIn: 'root' });
    return LoginService;
}());
/*@__PURE__*/ (function () { ɵsetClassMetadata(LoginService, [{
        type: Injectable,
        args: [{
                providedIn: 'root'
            }]
    }], function () { return [{ type: LibraryEnvironment, decorators: [{
                type: Inject,
                args: [EnvironmentToken]
            }] }, { type: HttpClient }]; }, null); })();

var ErrorPageComponent = /** @class */ (function () {
    function ErrorPageComponent() {
    }
    ErrorPageComponent.prototype.ngOnInit = function () {
    };
    ErrorPageComponent.ɵfac = function ErrorPageComponent_Factory(t) { return new (t || ErrorPageComponent)(); };
    ErrorPageComponent.ɵcmp = ɵɵdefineComponent({ type: ErrorPageComponent, selectors: [["lib-error-page"]], decls: 2, vars: 0, template: function ErrorPageComponent_Template(rf, ctx) { if (rf & 1) {
            ɵɵelementStart(0, "p");
            ɵɵtext(1, "error-page works!");
            ɵɵelementEnd();
        } }, styles: [""] });
    return ErrorPageComponent;
}());
/*@__PURE__*/ (function () { ɵsetClassMetadata(ErrorPageComponent, [{
        type: Component,
        args: [{
                selector: 'lib-error-page',
                templateUrl: './error-page.component.html',
                styleUrls: ['./error-page.component.css']
            }]
    }], function () { return []; }, null); })();

var NotificationService = /** @class */ (function () {
    function NotificationService(toastr) {
        this.toastr = toastr;
    }
    NotificationService.prototype.notify = function (message) {
        alert(message);
    };
    NotificationService.prototype.successmsg = function (message) {
        this.toastr.success(message, 'Success');
    };
    NotificationService.prototype.errorsmsg = function (message) {
        this.toastr.error(message, 'Error');
    };
    NotificationService.prototype.infotoastr = function (message) {
        this.toastr.info(message, 'Information');
    };
    NotificationService.prototype.toastrwaring = function (message) {
        this.toastr.warning(message, 'Warning');
    };
    NotificationService.ɵfac = function NotificationService_Factory(t) { return new (t || NotificationService)(ɵɵinject(ToastrService)); };
    NotificationService.ɵprov = ɵɵdefineInjectable({ token: NotificationService, factory: NotificationService.ɵfac, providedIn: 'root' });
    return NotificationService;
}());
/*@__PURE__*/ (function () { ɵsetClassMetadata(NotificationService, [{
        type: Injectable,
        args: [{
                providedIn: 'root'
            }]
    }], function () { return [{ type: ToastrService }]; }, null); })();

var ErrorHandlerService = /** @class */ (function () {
    function ErrorHandlerService(notify) {
        this.notify = notify;
    }
    ErrorHandlerService.prototype.handleError = function (response) {
        if (response.status === 0) {
            this.notify.errorsmsg('Server nije dostupan.');
        }
        else if (response.status === 400) {
            this.notify.errorsmsg(response.error + ".");
        }
    };
    ErrorHandlerService.ɵfac = function ErrorHandlerService_Factory(t) { return new (t || ErrorHandlerService)(ɵɵinject(NotificationService)); };
    ErrorHandlerService.ɵprov = ɵɵdefineInjectable({ token: ErrorHandlerService, factory: ErrorHandlerService.ɵfac, providedIn: 'root' });
    return ErrorHandlerService;
}());
/*@__PURE__*/ (function () { ɵsetClassMetadata(ErrorHandlerService, [{
        type: Injectable,
        args: [{
                providedIn: 'root'
            }]
    }], function () { return [{ type: NotificationService }]; }, null); })();

var LoginComponent = /** @class */ (function () {
    function LoginComponent(formBuilder, loginService, router, errorHandlerService) {
        this.formBuilder = formBuilder;
        this.loginService = loginService;
        this.router = router;
        this.errorHandlerService = errorHandlerService;
        this.loginForm = this.formBuilder.group({
            username: new FormControl('', [Validators.required]),
            password: new FormControl('', [Validators.required])
        });
    }
    LoginComponent.prototype.ngOnInit = function () {
        this.operaterAuthenticated();
    };
    LoginComponent.prototype.submit = function () {
        var _this = this;
        var loginCerdentials = {
            username: this.loginForm.controls.username.value,
            password: this.loginForm.controls.password.value
        };
        this.loginService.login(loginCerdentials).subscribe(function (loginResponse) {
            // this.loginService.loggedUser = loginResponse;
            sessionStorage.setItem('loggedUser', JSON.stringify(loginResponse));
            _this.operaterAuthenticated();
        }, function (error) {
            _this.errorHandlerService.handleError(error);
        });
    };
    LoginComponent.prototype.operaterAuthenticated = function () {
        if (sessionStorage.getItem('loggedUser')) {
            this.router.navigate(['dashboard', 'landing-page']);
        }
    };
    LoginComponent.prototype.navigate = function (route) {
        this.router.navigate([route]);
    };
    LoginComponent.ɵfac = function LoginComponent_Factory(t) { return new (t || LoginComponent)(ɵɵdirectiveInject(FormBuilder), ɵɵdirectiveInject(LoginService), ɵɵdirectiveInject(Router), ɵɵdirectiveInject(ErrorHandlerService)); };
    LoginComponent.ɵcmp = ɵɵdefineComponent({ type: LoginComponent, selectors: [["app-login"]], decls: 14, vars: 1, consts: [["autocomplete", "off", 3, "formGroup", "ngSubmit"], [1, "flexbox-column-container", "jumbotron"], ["for", "username", 1, "flexbox-label"], ["type", "text", "formControlName", "username", 1, "flexbox-item"], ["for", "password", 1, "flexbox-label"], ["type", "password", "formControlName", "password", 1, "flexbox-item"], [1, "flexbox-label"], ["type", "submit", 1, "btn", "btn-primary", "flexbox-item"]], template: function LoginComponent_Template(rf, ctx) { if (rf & 1) {
            ɵɵelementStart(0, "form", 0);
            ɵɵlistener("ngSubmit", function LoginComponent_Template_form_ngSubmit_0_listener() { return ctx.submit(); });
            ɵɵelementStart(1, "div", 1);
            ɵɵelementStart(2, "div");
            ɵɵelementStart(3, "label", 2);
            ɵɵtext(4, "Username: ");
            ɵɵelementEnd();
            ɵɵelement(5, "input", 3);
            ɵɵelementEnd();
            ɵɵelementStart(6, "div");
            ɵɵelementStart(7, "label", 4);
            ɵɵtext(8, "Password: ");
            ɵɵelementEnd();
            ɵɵelement(9, "input", 5);
            ɵɵelementEnd();
            ɵɵelementStart(10, "div");
            ɵɵelement(11, "label", 6);
            ɵɵelementStart(12, "button", 7);
            ɵɵtext(13, "Login");
            ɵɵelementEnd();
            ɵɵelementEnd();
            ɵɵelementEnd();
            ɵɵelementEnd();
        } if (rf & 2) {
            ɵɵproperty("formGroup", ctx.loginForm);
        } }, directives: [ɵangular_packages_forms_forms_y, NgControlStatusGroup, FormGroupDirective, DefaultValueAccessor, NgControlStatus, FormControlName], styles: [""] });
    return LoginComponent;
}());
/*@__PURE__*/ (function () { ɵsetClassMetadata(LoginComponent, [{
        type: Component,
        args: [{
                selector: 'app-login',
                templateUrl: './login.component.html',
                styleUrls: ['./login.component.css']
            }]
    }], function () { return [{ type: FormBuilder }, { type: LoginService }, { type: Router }, { type: ErrorHandlerService }]; }, null); })();

var WhLibraryModule = /** @class */ (function () {
    function WhLibraryModule() {
    }
    WhLibraryModule.forRoot = function (environment) {
        return {
            ngModule: WhLibraryModule,
            providers: [
                {
                    provide: EnvironmentToken,
                    useValue: environment
                }
            ]
        };
    };
    WhLibraryModule.ɵmod = ɵɵdefineNgModule({ type: WhLibraryModule });
    WhLibraryModule.ɵinj = ɵɵdefineInjector({ factory: function WhLibraryModule_Factory(t) { return new (t || WhLibraryModule)(); }, providers: [
            LoginService
        ], imports: [[
                HttpClientModule,
                ReactiveFormsModule,
                BrowserAnimationsModule,
                ToastrModule.forRoot({
                    timeOut: 5000,
                    positionClass: 'toast-bottom-full-width',
                    preventDuplicates: true,
                })
            ]] });
    return WhLibraryModule;
}());
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && ɵɵsetNgModuleScope(WhLibraryModule, { declarations: [LoginComponent,
        ErrorPageComponent], imports: [HttpClientModule,
        ReactiveFormsModule,
        BrowserAnimationsModule, ToastrModule], exports: [LoginComponent] }); })();
/*@__PURE__*/ (function () { ɵsetClassMetadata(WhLibraryModule, [{
        type: NgModule,
        args: [{
                declarations: [
                    LoginComponent,
                    ErrorPageComponent
                ],
                imports: [
                    HttpClientModule,
                    ReactiveFormsModule,
                    BrowserAnimationsModule,
                    ToastrModule.forRoot({
                        timeOut: 5000,
                        positionClass: 'toast-bottom-full-width',
                        preventDuplicates: true,
                    })
                ],
                providers: [
                    LoginService
                ],
                exports: [
                    LoginComponent
                ]
            }]
    }], null, null); })();

var Login = /** @class */ (function () {
    function Login() {
    }
    return Login;
}());

var LoggedUser = /** @class */ (function () {
    function LoggedUser() {
    }
    return LoggedUser;
}());

var AccessGuard = /** @class */ (function () {
    function AccessGuard(loginService) {
        this.loginService = loginService;
    }
    AccessGuard.prototype.canActivate = function () {
        return sessionStorage.getItem('loggedUser') ? of(true) : of(false);
    };
    AccessGuard.ɵfac = function AccessGuard_Factory(t) { return new (t || AccessGuard)(ɵɵinject(LoginService)); };
    AccessGuard.ɵprov = ɵɵdefineInjectable({ token: AccessGuard, factory: AccessGuard.ɵfac, providedIn: 'root' });
    return AccessGuard;
}());
/*@__PURE__*/ (function () { ɵsetClassMetadata(AccessGuard, [{
        type: Injectable,
        args: [{
                providedIn: 'root'
            }]
    }], function () { return [{ type: LoginService }]; }, null); })();

var HelperService = /** @class */ (function () {
    function HelperService() {
    }
    HelperService.prototype.unsubscribeSubscriptions = function (subscriptions) {
        subscriptions.forEach(function (x) {
            if (x) {
                x.unsubscribe();
            }
        });
    };
    HelperService.ɵfac = function HelperService_Factory(t) { return new (t || HelperService)(); };
    HelperService.ɵprov = ɵɵdefineInjectable({ token: HelperService, factory: HelperService.ɵfac, providedIn: 'root' });
    return HelperService;
}());
/*@__PURE__*/ (function () { ɵsetClassMetadata(HelperService, [{
        type: Injectable,
        args: [{
                providedIn: 'root'
            }]
    }], null, null); })();

var Category = /** @class */ (function () {
    function Category() {
    }
    return Category;
}());

var Engine = /** @class */ (function () {
    function Engine() {
    }
    return Engine;
}());

var Manufacturer = /** @class */ (function () {
    function Manufacturer() {
    }
    return Manufacturer;
}());

var Model = /** @class */ (function () {
    function Model() {
    }
    return Model;
}());

var Part = /** @class */ (function () {
    function Part() {
    }
    return Part;
}());

var SubCategory = /** @class */ (function () {
    function SubCategory() {
    }
    return SubCategory;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { AccessGuard, Category, Engine, ErrorHandlerService, HelperService, LoggedUser, Login, LoginComponent, LoginService, Manufacturer, Model, NotificationService, Part, SubCategory, WhLibraryModule };
//# sourceMappingURL=wh-library.js.map
